'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var makeRelative = require('./make-relative');

var walkObject = function () {
	var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(obj, iteratee) {
		var ignoreKeys = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
		var prop;
		return _regenerator2.default.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						_context.t0 = _regenerator2.default.keys(obj);

					case 1:
						if ((_context.t1 = _context.t0()).done) {
							_context.next = 21;
							break;
						}

						prop = _context.t1.value;

						if (!(ignoreKeys.indexOf(prop) !== -1)) {
							_context.next = 5;
							break;
						}

						return _context.abrupt('continue', 1);

					case 5:
						_context.t2 = (0, _typeof3.default)(obj[prop]);
						_context.next = _context.t2 === 'array' ? 8 : _context.t2 === 'object' ? 12 : 16;
						break;

					case 8:
						_context.next = 10;
						return walkArray(obj[prop], iteratee, ignoreKeys);

					case 10:
						obj[prop] = _context.sent;
						return _context.abrupt('break', 19);

					case 12:
						_context.next = 14;
						return walkObject(obj[prop], iteratee, ignoreKeys);

					case 14:
						obj[prop] = _context.sent;
						return _context.abrupt('break', 19);

					case 16:
						_context.next = 18;
						return iteratee(obj[prop]);

					case 18:
						obj[prop] = _context.sent;

					case 19:
						_context.next = 1;
						break;

					case 21:
						return _context.abrupt('return', obj);

					case 22:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, undefined);
	}));

	return function walkObject(_x, _x2) {
		return _ref.apply(this, arguments);
	};
}();

var walkArray = function () {
	var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(arr, iteratee) {
		var ignoreKeys = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
		return _regenerator2.default.wrap(function _callee3$(_context3) {
			while (1) {
				switch (_context3.prev = _context3.next) {
					case 0:
						return _context3.abrupt('return', arr.map(function () {
							var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(i) {
								var result;
								return _regenerator2.default.wrap(function _callee2$(_context2) {
									while (1) {
										switch (_context2.prev = _context2.next) {
											case 0:
												result = void 0;
												_context2.t0 = typeof i === 'undefined' ? 'undefined' : (0, _typeof3.default)(i);
												_context2.next = _context2.t0 === 'array' ? 4 : _context2.t0 === 'object' ? 8 : 12;
												break;

											case 4:
												_context2.next = 6;
												return walkArray(i, iteratee, ignoreKeys);

											case 6:
												result = _context2.sent;
												return _context2.abrupt('break', 15);

											case 8:
												_context2.next = 10;
												return walkObject(i, iteratee, ignoreKeys);

											case 10:
												result = _context2.sent;
												return _context2.abrupt('break', 15);

											case 12:
												_context2.next = 14;
												return iteratee(i);

											case 14:
												result = _context2.sent;

											case 15:
												return _context2.abrupt('return', result);

											case 16:
											case 'end':
												return _context2.stop();
										}
									}
								}, _callee2, undefined);
							}));

							return function (_x7) {
								return _ref3.apply(this, arguments);
							};
						}()));

					case 1:
					case 'end':
						return _context3.stop();
				}
			}
		}, _callee3, undefined);
	}));

	return function walkArray(_x4, _x5) {
		return _ref2.apply(this, arguments);
	};
}();

exports.onCreateNode = function () {
	var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(_ref5, options) {
		var node = _ref5.node,
		    getNode = _ref5.getNode;
		var commonProps, nodeAbsPath, iteratee;
		return _regenerator2.default.wrap(function _callee5$(_context5) {
			while (1) {
				switch (_context5.prev = _context5.next) {
					case 0:
						commonProps = ['id', '_PARENT', 'parent', 'children', 'internal'];
						nodeAbsPath = void 0;

						iteratee = function () {
							var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(val) {
								return _regenerator2.default.wrap(function _callee4$(_context4) {
									while (1) {
										switch (_context4.prev = _context4.next) {
											case 0:
												_context4.next = 2;
												return makeRelative(nodeAbsPath, val, options);

											case 2:
												return _context4.abrupt('return', _context4.sent);

											case 3:
											case 'end':
												return _context4.stop();
										}
									}
								}, _callee4, undefined);
							}));

							return function iteratee(_x10) {
								return _ref6.apply(this, arguments);
							};
						}();

						if (!(node.internal.type === 'MarkdownRemark')) {
							_context5.next = 10;
							break;
						}

						nodeAbsPath = node.fileAbsolutePath;

						if (!((0, _typeof3.default)(node.frontmatter) === 'object')) {
							_context5.next = 8;
							break;
						}

						_context5.next = 8;
						return walkObject(node.frontmatter, iteratee, commonProps);

					case 8:
						_context5.next = 14;
						break;

					case 10:
						if (!/^\w+(Yaml|Json)$/.test(node.internal.type)) {
							_context5.next = 14;
							break;
						}

						nodeAbsPath = getNode(node.parent).absolutePath;

						_context5.next = 14;
						return walkObject(node, iteratee, commonProps);

					case 14:
					case 'end':
						return _context5.stop();
				}
			}
		}, _callee5, undefined);
	}));

	return function (_x8, _x9) {
		return _ref4.apply(this, arguments);
	};
}();
//# sourceMappingURL=gatsby-node.js.map